%

function [im_n,band_n,band_r,phase_err] = DAPS(im_l,lev_num,ori_num,disp,im_r,is_refine,params)
tic;
% gpu = gpuDevice();

if ~isempty(im_r)
    [pyr_im_r,ind_im_r]=buildSCFpyr(double(im_r),lev_num,ori_num);
end

[pyr_im_l,ind_im_l]=buildSCFpyr(double(im_l),lev_num,ori_num);

band_n = zeros(size(im_l,1),size(im_l,2),lev_num*(ori_num+1)+2);
band_r = zeros(size(im_l,1),size(im_l,2),lev_num*(ori_num+1)+2);
phase_err = ones(size(im_l,1),size(im_l,2),lev_num*(ori_num+1)+2);

if(is_refine)
    th_val = 1.5;
    m_pixel = round(16*size(disp,2)/1024);
%     th_val = 1.5;
%     m_pixel = 8;

    disp = ArtifactsRemove(disp,th_val,m_pixel);
end

npyr = pyr_im_l;
ctr = ceil((size(im_l)+0.5)/2);
fprintf('synthesis band ');

for k = 1:lev_num*(ori_num+1)+2
    
   
    
    fprintf('%2d. ',k);
    band = pyrBand(pyr_im_l,ind_im_l,k);
    
    f = fft2(band);
    if(size(f,1)~=size(disp,1))
        f=fftshift(f);
        lodims = size(f);
        a = mod(lodims(1),2);
        b = mod(lodims(2),2);
        loctr = ceil((lodims+0.5)/2);
        lostart = ctr-loctr+1;
        loend = lostart+lodims-1;
        nf = zeros(size(im_l,1),size(im_l,2));
        nf(lostart(1):loend(1),lostart(2):loend(2)) = f;
        nf = fftshift(nf);
        newband = FastCmptBand(nf,disp,params);
        band_n(:,:,k) = newband;
        nf = fftshift(fft2(newband));
        newband = nf(lostart(1)-a:loend(1)-a,lostart(2)-b:loend(2)-b);
        newband = ifft2(fftshift(newband));
        nf = zeros(size(im_l,1),size(im_l,2));
        
        if ~isempty(im_r)
            band = pyrBand(pyr_im_r,ind_im_r,k);
            nf(lostart(1):loend(1),lostart(2):loend(2)) = fftshift(fft2(band));
            band_r(:,:,k) = ifft2(fftshift(nf));
            phase_err(:,:,k) = band_r(:,:,k)./band_n(:,:,k);
        end
        
        %         nf((size(im_l,1)/2)-(size(f,1)/2)+1:(size(im_l,1)/2)+(size(f,1)/2),(size(im_l,2)/2)-(size(f,2)/2)+1:(size(im_l,2)/2)+(size(f,2)/2)) = f;
        %         nf = fftshift(nf);
        %         num = max(ceil((k-1)/(ori_num+1)),1);
        %         newband = depphase(nf,disp);
        %         nf = fftshift(fft2(newband));
        %         newband = nf((size(im_l,1)/2)-(size(f,1)/2)+1:(size(im_l,1)/2)+(size(f,1)/2),(size(im_l,2)/2)-(size(f,2)/2)+1:(size(im_l,2)/2)+(size(f,2)/2));
        %         newband = ifft2(fftshift(newband));
        
        npyr = setPyrBand(npyr,ind_im_l,newband,k);
    else
        if k==1 %hi pass filter
            
            newband = FastCmptBand(f,round(disp),params);
            band_n(:,:,k) = newband;            
            npyr = setPyrBand(npyr,ind_im_l,newband,k);
            if ~isempty(im_r)
                band = pyrBand(pyr_im_r,ind_im_r,k);
                band_r(:,:,k) = band;
                phase_err(:,:,k) = band./newband;
            end
        else
            
            newband = FastCmptBand(f,disp,params);
            band_n(:,:,k) = newband;
            npyr = setPyrBand(npyr,ind_im_l,newband,k);
             
            if ~isempty(im_r)
                band = pyrBand(pyr_im_r,ind_im_r,k);
                band_r(:,:,k) = band;
                phase_err(:,:,k) = band./newband;
            end
           
        end
    end
    
    
end

im_n = reconSCFpyr(npyr,ind_im_l);

% wait(gpu);
% reset(gpu);
toc;
end