function band_n = FastCmptBand(f,disp,params)

% clear;
% load('sp_FastCmptBand','f','disp');



[m,n] = size(f);
mtx_l =  (conj(dftmtx(m))/m) *f;%inverse discrete Fourier transform
mtx_r = conj(dftmtx(n))/n; 

r = floor(n/2)+1; 
g = ((1:n)-r)/(n/2);
g = ifftshift(g);
g = -1j*g*pi;
band_n = zeros(size(mtx_l));

% gpu = gpuDevice(params.gpu_id);
gpu = gpuDevice();

fprintf('id %d ',gpu.Index);

g = single(g);
mtx_l = single(mtx_l);
mtx_r = single(mtx_r);
disp = single(disp);
band_n = single(band_n);

gG = gpuArray(g);
gL = gpuArray(mtx_l);
gR = gpuArray(mtx_r);
gD = gpuArray(disp);
gBand = gpuArray(band_n);
% tic;
for l = 1:n
    gBand(:,l) = gL.*exp(gD(:,l)*gG)*gR(:,l);
end

band_n = gather(gBand);
band_n = double(band_n);

% toc;

wait(gpu);
reset(gpu);



% band_t = band_n;

% load('band_t','band_t');
% 
% sum(sum(abs(band_t - band_n)))
% max(max(abs(band_t - band_n)))

end