% refine the disparity by DAPS

function disp_rf = FastRefineDisp(im_l,im_r,disp_0,lev_num,ori_num,params)

% save('debug_fast_RefineDisp','im_l','im_r','disp_0','lev_num','ori_num');
% tic;
[~,band_n,band_r,phase_err] = DAPS(im_l,lev_num,ori_num,-disp_0,im_r,0,params);
% toc;
[im_h,im_w] = size(disp_0);

% fiterr = zeros(im_h,im_w);

l = 4; % number of bands contributes to the final err 
% tic;
norm = abs(band_n+band_r)/2;
[~,ind] = sort(norm,3,'descend');

I = repmat([1:im_h]',im_w*l,1);
J = repmat(reshape(ones(im_h,1)*[1:im_w],im_w*im_h,1),l,1);
K = reshape(ind(:,:,1:l),im_w*im_h*l,1);

sel_ind = sub2ind(size(norm),I,J,K);

ang = angle(phase_err(sel_ind));
ang = reshape(ang,im_h,im_w,l);


ori_ang = cos( ind(:,:,1:l)*pi/(ori_num + 1) );
% 
disp_err = sum(ori_ang.*ang,3)./sum(ori_ang.*ori_ang,3);

disp_rf = disp_0 + disp_err*2/pi; % w_0 is pi/2

% toc;
end