function medianFiltered = weightedMedianMatlab(left_img,disp_img,winsize,gamma_c,gamma_p)
[h,w,c] = size(left_img);
disp_img = round(disp_img*1000);
smoothed_left_img = medfilt2(left_img(:,:,1));
smoothed_left_img(:,:,2) = medfilt2(left_img(:,:,2));
smoothed_left_img(:,:,3) = medfilt2(left_img(:,:,3));

radius = floor(winsize/2);

[xx,yy] = meshgrid(-radius:radius,-radius:radius);
sdiff_t = sqrt( xx.^2 + yy.^2 );
x_c = radius +1;
y_c = radius +1;

medianFiltered = zeros(h,w);


for y = 1:h
    for x = 1:w
        
        y_ind = max(1,y-radius):min(h,y+radius);
        x_ind = max(1,x-radius):min(w,x+radius);
        
        patch_h = length(y_ind);
        patch_w = length(x_ind);
        
        centercol = smoothed_left_img(y,x,:);
        curPatch = smoothed_left_img(y_ind,x_ind,:);
                
        t1 = zeros(patch_h,patch_w);
        for k = 1:c
            t1 = t1 + (centercol(k) - curPatch(:,:,k)).^2;
        end

        coldiff = sqrt(t1);
        sdiff = sdiff_t(y_ind - y +y_c,x_ind - x + x_c);
        
        maskVals = exp(-1 * coldiff ./ (gamma_c*gamma_c) -1 * sdiff ./ (gamma_p*gamma_p));
        
        maskVals = maskVals(:);
      
        dispVals = disp_img(y_ind,x_ind);
        dispVals = dispVals(:);
        [dispVals_s,disp_ind] = sort(dispVals);
        maskVals = maskVals(disp_ind);
        m_sum = sum(maskVals);
        m_csum = cumsum(maskVals);
        med_ind = find(m_csum > m_sum/2,1);
        
        medianFiltered(y,x) = dispVals_s(med_ind)/1000;
       
    end
end

end